#define PERSPECTSPAN 90.0
#define PANORAMAVERTICALVIEWANGLE 10.0
#define FBGLNEAR 0.05
#define FBGLFAR 50.0
#define OMMATIDIA 360
#define USEANISOTROPICFILTERING true
// Misschien kan ik de perspectspan per bijresolutieniveau aanpassen en zorgen dat ie net een cel meer kan zien zodat de 5 zichtvelden overlappen?

float howmuchbiggerismyfacet(float x,float y);
void drawtexturedquad(float l,float r,float u,float d);//Ive been down so long it looks like up to me

class framebufferobject
{
public:
	framebufferobject(int width, int height);
	framebufferobject(int width, int height,bool linear);
	framebufferobject(int width, int height,bool linear,bool depth);
	framebufferobject(int width, int height,bool linear,bool depth,bool repeat);
	framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap);
	framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating);
	framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating,bool alpha);
	framebufferobject(int width, int height,bool linear,bool depth,bool repeat,bool mipmap,bool floating,bool alpha,float perspectiefgrootte);
	
	framebufferobject(int resolutie,float hoek,float dichtbij);
	
	~framebufferobject();
	void zetmij(int width,int height,bool near_lin,bool doeikdiepte,bool repeat,bool mipmap,bool floating,bool alpha,float perspectiefgrootte);
	void bindtexture();
	void binddepthtexture();
	void genereermipmaps();
	void bindframebuffer();
	int getW();
	int getH();
	GLuint mijntexlocation();
	void tekentexture();
	void tekenquad();
	float *readtexdata();
	float getnear();
	void saveaspng(const char *filename);

private:
	GLuint FramebufferName;
	GLuint renderedTexture;
	GLuint depthBuffer;
	GLuint depthTexture;
	GLenum drawbufs[1];//={GL_COLOR_ATTACHMENT0};
	int W,H;
	bool metdiepte;
	bool metfloat,metalpha;
	bool metmipmaps,netgeframebuffered;
	float *texturedata;
	bool ikbendeelvanpanorama;
	float mijnperspectiefhoek,mijnglnear;
	
};




class panorama
{
public:
	panorama();
	~panorama();
	void initialiseer(int segmenten,float totalehorizonhoek,int totalepanresolutie,GLhandleARB diepteverwerkerp);
	void bindrenderbuffer(int bufnum);
	void verwerk();
	void lijmbuffers();
	void bindzichttexture();
	void binddieptetexture();
	float draaiwereld(int bufnum);
	bool checkversheid();
	int clampbuf(int bufnum);
	float geteffectievetotaleperspectief();
	bool getgaatierond();
	float tothoek();
	float getnear();
	void bindoogindelingtexture();
	float *geefmijnhoekpercel();
	framebufferobject *samenzicht[2];
private:
	bool ikbenvers;
	int mijnbufaantal,mijntotaleresolutie;
	float mijntotalehorizontalehoek,segmenthoek;
	framebufferobject **panbufs;
	framebufferobject *mijnoogindeling;
	int cur;
	bool ikgarond;
	float *mijnhoekpercel;
	GLhandleARB mijndiepteverwerkerp;
};

class horizonfacetten
{
public:
	horizonfacetten();
	~horizonfacetten();
	void initialiseer(panorama *datahaalpunt,int aantalcellen,int tijdresolutie,GLhandleARB bewegingsdetectiep,GLhandleARB prefilterp,GLhandleARB edgep,GLhandleARB distcalcp); //in plaats hiervan beter op TIJDRESOLUTIE gebaseerd aantal frames waarbij daan het einde van de vooruitstap een berekening wordt gedaan over alle frames en de snelheden bepaald.
	void update();
	void bindtexture(int i);
	void verwerkdata(float lengtestap);
	void zethoek(int h);
	void geefvertexengevondenafstanden(vect bijpos,float bijrot,vect kleur,class wereld *dewereld);
	void zetdistbewerkerp(GLhandleARB distbewerkerp);
private:
	panorama *mijnpanorama;
	framebufferobject *facetten;
	framebufferobject *output,*maxoutput,*distoutput,*disttussenstap;
	int mijnaantalcellen;
	GLhandleARB mijnbewegingsdetectiep,mijnprefilterp,mijnedgep,mijndistcalcp,mijndistverwerkerp;
	int currenthoek;
	bool doeikdistbewerken;
	int mijntijdresolutie,mijncounter;
	float *dists;//,*speeds;
	//vect offsetvanbij;
	//float hoekgrenzen[2];
	//float totalehoek;
};

class voetstaarder
{
public:
	voetstaarder();
	~voetstaarder();
	void initialiseer(int retinadiameter,int aantalrichtingen,int tijdresolutie,float kijkhoek,float oogmult,GLhandleARB bewegingsdetectiep,GLhandleARB prefilterp,GLhandleARB edgep); 
	void bindoogfb();
	void bindtexture(int i);
	void takeaslice();
	void setinitialpos(vect bijpos,int wereldradius);
	vect verwerkdata(vect bijwarp);
	vect laatstestap();
	vect oedipos();
	void reset(vect nwpos);
	void switchstrategie();
	float welkerichtinggaikop();
private:
	framebufferobject *oog;
	framebufferobject ***lijn;
	GLhandleARB mijnbewegingsdetectiep,mijnprefilterp,mijnedgep;
	int mijntijdresolutie,mijnretinadiameter,mijnaantalrichtingen;
	float mijnkijkhoek;
	vect uitkomst;
	int mijnslicecounter;
	float *avgvals;
	vect uitkomstenpos;
	int mijnwereldradius;
	int hoevaakgereset;
	bool grootstecontinugebruiken;
	float mijnrichting;
};


