#version 110

varying vec2 texcoord;
uniform sampler2D facetten; 


uniform float M_PI;
uniform float snelheidradianmult; //mijntijdresolutie*(tothoek/mijnaantalcellen) want dat is dus de maximale radiansnelheid die kan
uniform float lengtestap;
uniform float maxdist;

void main()
{	

	float snelheid=abs(texture2D(facetten,texcoord).r);//*snelheidradianmult;
	
	if(snelheid==0.0) discard; //Anders tekent ie alle zwarte... Oftewel: De 0 snelheid hebbende..

	snelheid*=snelheidradianmult;
	
	float beta=length(texcoord.s-0.5)*M_PI*2.0;
	
	float phi=M_PI-(snelheid+(M_PI-beta));



	float afstandtotpunt=(lengtestap/sin(snelheid))*sin(phi);
	
	//if(afstandtotpunt>maxdist) gl_FragColor=vec4(0.0);	
	//else 
	gl_FragColor=vec4(afstandtotpunt/maxdist);///maxdist);//sqrt(m-((l+r+ll+rr)*0.25));
	

}


