#include <math.h>
#include <stdlib.h> 
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>    
//#include <GL/gl.h>
//#include <GL/glu.h>
#include <cstring>
#include "vect.h"



float* vect::pos(int i)
{
	if(i<=0) return &x;
	if(i==1) return &y;
	return &z;
}

float randfloat(float min,float max)
{

	float r=((float)(rand()%100000000))/100000000.0f;
	float uit=min+(r*(max-min));


	return uit;
}


void vect::addruis()
{
	x+=randfloat(-0.0001,0.0001);
	y+=randfloat(-0.0001,0.0001);
	z+=randfloat(-0.0001,0.0001);
}
/*
bool vect::nanfbevat()
{
	return isnanf(x) || isnanf(y) || isnanf(z);
}

void vect::checkfornanf()
{
	if(isnanf(x)) x=randfloat(-2,2);
	if(isnanf(y)) y=randfloat(-2,2);
	if(isnanf(z)) z=randfloat(-2,2);
}*/

void vect::stringifymij(char *uit,int l)
{

	memset(uit,0,l);
	sprintf(uit,"{(%f,%f,%f),|mij|=%f} ",x,y,z,sqrtf(powf(x,2)+powf(y,2)+powf(z,2)));
}


vect::vect()
{
	x=0;
	y=0;
	z=0;
}


vect::vect(float xx,float yy,float zz)
{
	x=xx;
	y=yy;
	z=zz;
}

vect::vect(float val)
{
	x=val;
	y=val;
	z=val;
}

vect::vect(const vect &kopieermij)
{
	x=kopieermij.x;
	y=kopieermij.y;
	z=kopieermij.z;
}

vect* vect::zetmij(float xx,float yy,float zz)
{
	x=xx;
	y=yy;
	z=zz;
	return this;
}

vect* vect::zetmij(vect kopieermij)
{
	x=kopieermij.x;
	y=kopieermij.y;
	z=kopieermij.z;
	return this;
}

float vectafstand(vect a,vect b)
{
	return vectlengte(vectminvect(a,b));
}

vect vectmatrixmult(vect ori,float matrix[3][3])
{
	//printf("uhmmmm2....\n");
	vect uit;
	uit.x=matrix[0][0]*ori.x+matrix[1][0]*ori.y+matrix[2][0]*ori.z;
	uit.y=matrix[0][1]*ori.x+matrix[1][1]*ori.y+matrix[2][1]*ori.z;
	uit.z=matrix[0][2]*ori.x+matrix[1][2]*ori.y+matrix[2][2]*ori.z;
	return uit;

}

vect vectrotatearoundvect(vect in,vect as,float alpha) //Mogelijkerwijs is deze kaput
{
		vect normaleas;
		normaleas.zetmij(vectnormalize(as));				
				
		float a=normaleas.x,b=normaleas.y,c=normaleas.z;
		float K=cosf(alpha);
		float rotaroundas[3][3]={	{a*a*K+cosf(alpha),a*b*K+c*sinf(alpha),a*c*K-b*sinf(alpha)},
						{a*b*K-c*sinf(alpha),b*b*K+cosf(alpha),b*c*K+a*sinf(alpha)},
						{a*c*K+b*sinf(alpha),c*b*K-a*sinf(alpha),c*c*K+cosf(alpha)}};
		vect uit;
		uit.zetmij(vectnormalize(vectmatrixmult(in,rotaroundas)));
		return uit;
}



vect doenormaal(vect hoek0,vect hoek1,vect hoek2)
{
	
	vect v=vectnormalize(vectminvect(hoek1,hoek0));
	vect u=vectnormalize(vectminvect(hoek2,hoek0));

	
	return vectnormalize(vectkruisproduct(u,v));
}

float 	vectlengte(vect nienormal)		{ return sqrtf(nienormal.x*nienormal.x+nienormal.y*nienormal.y+nienormal.z*nienormal.z);	}
vect 	vectminvect(vect a,vect b)		{ return vect(a.x-b.x,a.y-b.y,a.z-b.z);	}
vect 	vectmult(vect a,float x)		{ return vect(a.x*x,a.y*x,a.z*x);	}
vect 	vectmultvect(vect a,vect b)		{ return vect(a.x*b.x,a.y*b.y,a.z*b.z);	}
vect 	vectplusvect(vect a,vect b)		{ return vect(a.x+b.x,a.y+b.y,a.z+b.z); }
vect 	vectnormalize(vect normal)		{ float lengte=vectlengte(normal);	return vect((1/lengte)*normal.x,(1/lengte)*normal.y,(1/lengte)*normal.z); }
float 	vectdotproduct(vect a,vect b) 	{ return ((a.x*b.x) + (a.y*b.y) + (a.z*b.z)); }
float 	vectwelkehoek(vect a,vect b)	{ return acosf( (a.x*b.x + a.y*b.y + a.z*b.z) / (vectlengte(a) * vectlengte(b))  ); }
vect 	vectkruisproduct(vect a,vect b) { return vect(a.y*b.z-a.z*b.y, a.x*b.z-a.z*b.x, a.x*b.y-a.y*b.x);}
void 	vertexvect(vect a)				{ glVertex3f(a.x,a.y,a.z);};
void 	colorvect(vect a)				{ glColor3f(a.x,a.y,a.z);};
void 	normalvect(vect a)				{ glNormal3f(a.x,a.y,a.z);};
void 	vertexisooknormalvect(vect a)	{ normalvect(vectnormalize(a)); vertexvect(a); }
vect 	vectinterpoleer(vect a,vect b)	{ return vect(vectplusvect(a,vectmult(vectminvect(b,a),0.5))); }
